// $Id: RegexAux.h 1133 2020-07-15 14:19:04Z ge $
/// \file RegexAux.h
/// \brief contains auxiliary regular expression functions
///
/// $Revision: 1133 $
/// \author Gerald Weber <gweberbh@gmail.com>
#ifndef GBC_REGEXAUX_H
#define GBC_REGEXAUX_H "$Id: RegexAux.h 1133 2020-07-15 14:19:04Z ge $"

#include <boost/regex.hpp>
#include <string>

inline double assign(double &temp, std::string found)
  {
  temp=std::atof(found.c_str());
  return temp;
  }
  
inline int assign(int &temp, std::string found)
  {
  temp=std::atoi(found.c_str());
  return temp;
  }
  
inline bool reg_match(std::string target, std::string pat)
  {
  boost::regex pattern(pat);
  boost::smatch what;
  return boost::regex_search(target,what,pattern);
  }
  
inline std::string reg_match_string(const std::string &target, boost::regex &pat)
  {
  boost::smatch what;
  if (boost::regex_search(target,what,pat))  return what[1];
  else return std::string();
  }
  
  
#endif
